"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.whatCase = exports.controlCase = exports.NamingCasesArray = exports.NamingCases = exports.NamingCase = void 0;
var NamingCase;
(function (NamingCase) {
    NamingCase["CamelCase"] = "CamelCase";
    NamingCase["PascalCase"] = "PascalCase";
    NamingCase["SnakeCase"] = "SnakeCase";
    NamingCase["UpperCase"] = "UpperCase";
    NamingCase["LowerCase"] = "LowerCase";
    NamingCase["KebabCase"] = "KebabCase";
    NamingCase["StartCase"] = "StartCase";
    NamingCase["DotCase"] = "DotCase";
    NamingCase["PathCase"] = "PathCase";
    NamingCase["SpaceCase"] = "SpaceCase";
    NamingCase["NoCase"] = "NoCase";
    NamingCase["ConstantCase"] = "ConstantCase";
    NamingCase["SentenceCase"] = "SentenceCase";
    NamingCase["Unknown"] = "Unknown";
})(NamingCase = exports.NamingCase || (exports.NamingCase = {}));
exports.NamingCases = {
    [NamingCase.CamelCase]: /^[a-z][a-zA-Z0-9]*$/,
    [NamingCase.PascalCase]: /^[A-Z][a-zA-Z0-9]*$/,
    [NamingCase.SnakeCase]: /^[a-z][a-z0-9_]*$/,
    [NamingCase.UpperCase]: /^[A-Z][A-Z0-9]*$/,
    [NamingCase.LowerCase]: /^[a-z][a-z0-9]*$/,
    [NamingCase.KebabCase]: /^[a-z][a-z0-9-]*$/,
    [NamingCase.StartCase]: /^[A-Z][a-z0-9 ]*$/,
    [NamingCase.DotCase]: /^[a-z][a-z0-9.]*$/,
    [NamingCase.PathCase]: /^[a-z][a-z0-9/]*$/,
    [NamingCase.SpaceCase]: /^[a-z][a-z0-9 ]*$/,
    [NamingCase.NoCase]: /^[a-z][a-z0-9]*$/,
    [NamingCase.ConstantCase]: /^[A-Z][A-Z0-9_]*$/,
    [NamingCase.SentenceCase]: /^[A-Z][a-z0-9 ]*$/,
    [NamingCase.Unknown]: /^.*$/
};
exports.NamingCasesArray = Object.entries(exports.NamingCases).map(([type, regexp]) => ({
    regexp,
    type: type
}));
const controlCase = (str, caseType) => exports.NamingCases[caseType].test(str);
exports.controlCase = controlCase;
const whatCase = (str) => { var _a; return ((_a = exports.NamingCasesArray.find(({ regexp }) => regexp.test(str))) === null || _a === void 0 ? void 0 : _a.type) || NamingCase.Unknown; };
exports.whatCase = whatCase;
